module tonegen (
		input clk, // 50MHz
		input reset,
		input logic [15:0] writedata,
		input logic write,
		input logic [7:0]  address,
		input chipselect,
		input left_chan_ready,
		input right_chan_ready,
		output logic [15:0] sample_data_l,
		output logic sample_valid_l,
		output logic [15:0] sample_data_r,
		output logic sample_valid_r
	);
	reg [11:0] counter;
	reg state;
        reg control;

	//reg c_clk;
	//reg [18:0] count;
	

	reg	[16:0]  address0;
	wire	[15:0]  q0;

	background audio0(.address(address0), .clock(clk), .q(q0)); //40000

	
	reg	[14:0]  address1;
	wire	[15:0]  q1;
	shoot audio1(.address(address1), .clock(clk), .q(q1));//4978
	
	/*always_ff @(posedge clk) begin
		if(reset) count <= 0;
		else begin
			count <= count + 1;
		end
	end
	assign c_clk = count[18]; // overflows at 200Hz*/

	always_ff @(posedge clk) begin
		if(reset) begin
			counter <= 0;
			sample_valid_l <= 0; sample_valid_r <= 0;
			control <= 0;
			state <= 0;
		end
		else if (chipselect && write) begin
			case(address)
			8'd231: control <= writedata[0];
			endcase
	 	end

		else if(left_chan_ready == 1 && right_chan_ready == 1 && counter < 3125) begin
			counter <= counter + 1;
			sample_valid_l <= 0; sample_valid_r <= 0;
		end
		else if(left_chan_ready == 1 && right_chan_ready == 1 && counter == 3125) begin
			//if(counter == 3125) begin
				counter <= 0;
				sample_data_l <= q0;
				sample_data_r <= q0;
				//sample_data_l <= (c_clk << 14);
				//sample_data_r <= (c_clk << 14);
				address0 <= address0 + 1;
				sample_valid_l <= 1; sample_valid_r <= 1;
				if(address0 == 40000) begin
					address0 <= 0;
				end
				if(control == 1) begin
				    address1 <= 0;
				    state <= 1;
				end
				if(state) begin
				    control <= 0;
				    address1 <= address1 + 1;
				    sample_data_l <= (q0>>1) + (q1>>1); 
				    sample_data_r <= (q0>>1) + (q1>>1);
				    if(address1 <= 4978) begin
						address1 <= 0;
						state <= 0;
				    end
				end
		end
			else begin
				sample_valid_l <= 0; sample_valid_r <= 0;
			end
		//end
	end


	endmodule
