

module top_level(input logic        clk,
	        input logic 	   reset,
		input logic [15:0]  writedata,
		input logic 	   write,
		input 		   chipselect,
		input logic [7:0]  address,
		input logic 	   read,

		inout PS2_CLK,
		inout PS2_DAT,

		input left_chan_ready,
		input right_chan_ready,
		output logic [15:0] sample_data,
		output logic sample_valid,


		input  [3:0]        KEY,
		

		output logic [15:0] readdata,

		output logic [7:0] VGA_R, VGA_G, VGA_B,
		output logic 	   VGA_CLK, VGA_HS, VGA_VS,
		                   VGA_BLANK_n,
		output logic 	   VGA_SYNC_n		
		);

	vga_ball vga(
		  	.clk(clk),
	       		.reset(reset),
			.writedata(writedata),
		 	.write(write),
			.chipselect(chipselect),
			.address(address),

			.VGA_R(VGA_R),
			.VGA_G(VGA_G), 
			.VGA_B(VGA_B),
			.VGA_CLK(VGA_CLK), 
			.VGA_HS(VGA_HS), 
			.VGA_VS(VGA_VS),
		        .VGA_BLANK_n(VGA_BLANK_n),
			.VGA_SYNC_n(VGA_SYNC_n)
			);
	ps2_mouse mouse(
			.clk(clk),
	       		.reset(reset),
			.read(read),
			.write(write),
			.chipselect(chipselect),
			.address(address),
			.PS2_CLK(PS2_CLK),
			.PS2_DAT(PS2_DAT),
			.readdata(readdata),
			.writedata(writedata)
			);
/*	tonegen tg(
			.clk(clk), 
			.reset(~KEY[0]), 
			.writedata(writedata),
		 	.write(write),
			.address(address), 
			.chipselect(chipselect),
			.left_chan_ready(left_chan_ready),
    			.right_chan_ready(right_chan_ready), 
			.sample_data(sample_data), 
			.sample_valid(sample_valid));*/

endmodule
