

#include <stdio.h>
#include "vga_ball.h"
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <time.h>

int vga_ball_fd;
struct point{
  int x;
  int y;
  int x_direction;
  int y_direction;
  int dead;
};
struct Centipede{
  int x;
  int y;
  int pre_x;
  int pre_y;
  int moveDown;
  int moveSide;
  int downcount;
  int dead;
  int head;
  int state;
};
struct Bullet{
  int x;
  int y;
  int dead;
};
struct point Spider;
struct Centipede c[10];
struct point Player;
struct Bullet b[30];
int title[40];
int M[30][48];
int mouseX, mouseY,lef,rig,mid;
int isFired;
int countBullet = 0;
int Life  = 3;
int Score = 0;
int DieCentipede = 0;
int highestScore;
vga_ball_background mushroom;
vga_ball_centipede centipede;
vga_ball_bullet bullet;
vga_ball_object player;
vga_ball_object spider;
vga_ball_mouse mouse;
vga_ball_title Title;
vga_ball_state State;
void Initialization(){
  int i;
  int j;
  Spider.x = 0x0f;
  Spider.y = 0;
  Spider.x_direction = 1;
  Spider.y_direction = 1;
  Spider.dead = 1;
  Player.y = 350;
  Player.x = 450;
  Player.dead = 0;
  Player.x_direction = 0;
  Player.y_direction = 0;
  isFired = 0;
  DieCentipede = 0;
  c[0].x = 0;
  c[0].y = 160;
  c[0].pre_x = c[0].x;
  c[0].pre_y = c[0].y;
  c[0].moveDown = 1;
  c[0].moveSide = 1;
  c[0].dead = 0;
  c[0].downcount = 0;
  c[0].head = 1;
  c[0].state = 3;
  for(i = 1; i < 10;i++){
    c[i].x = 0;
    c[i].y = c[i-1].y - 16;
    c[i].pre_x = c[i].x;
    c[i].pre_y = c[i].y;
    c[i].moveDown = 1;
    c[i].moveSide = 1;
    c[i].dead = 0;
    c[i].downcount = 0;
    c[i].head = 0;
    c[i].state = 2;
  }
  for(i = 0 ; i < 30; i++){
    b[i].dead = 1;
    b[i].x = 700;
    b[i].y = 700;
  }
  memset(&mushroom, 0, 2 * 90);
  memset(&bullet, 300, 2*30);
  for(i = 1; i < 26; i ++){
    for(j = 0; j < 48; j++){
      if((rand() % 100) < 5){
         M[i][j] = 1;
      }else{
         M[i][j] = 0;
      }
    }
  }
  for(i = 0;i<40;i++){
    title[i] = 12;
  }
}
void set_background(vga_ball_background *c)
{
  vga_ball_background mushroom;
  mushroom = *c;
  if (ioctl(vga_ball_fd, VGA_BALL_WRITE_BACKGROUND, &mushroom)) {
      perror("ioctl(VGA_BALL_SET_BACKGROUND) failed");
      return;
  }
}
void set_title(vga_ball_title *c)
{
  vga_ball_title title;
  title  = *c;
  if (ioctl(vga_ball_fd, VGA_BALL_WRITE_TITLE, &title)) {
      perror("ioctl(VGA_BALL_SET_TITLE) failed");
      return;
  } 
}
void set_state(vga_ball_state *c)
{
  vga_ball_state state;
  state = *c;
  if (ioctl(vga_ball_fd, VGA_BALL_WRITE_STATE, &state)) {
      perror("ioctl(VGA_BALL_SET_STATE) failed");
      return;
  } 
}
void set_start(vga_ball_start *c)
{
  vga_ball_start start;
  start = *c;
  if (ioctl(vga_ball_fd, VGA_BALL_WRITE_START, &start)) {
      perror("ioctl(VGA_BALL_SET_BACKGROUND) failed");
      return;
  }
}

void set_centipede(vga_ball_centipede *c)
{
  vga_ball_centipede centipede;
  centipede = *c;
  if (ioctl(vga_ball_fd, VGA_BALL_WRITE_CENTIPEDE, &centipede)) {
      perror("ioctl(VGA_BALL_SET_CENTIPEDE) failed");
      return;
  }
}

void set_bullet(vga_ball_bullet *c)
{
  vga_ball_bullet bullet;
  bullet = *c;
  if (ioctl(vga_ball_fd, VGA_BALL_WRITE_BULLET, &bullet)) {
      perror("ioctl(VGA_BALL_SET_BULLET) failed");
      return;
  }
}

void set_player(vga_ball_object *c)
{
  vga_ball_object player;
  player = *c;
  if (ioctl(vga_ball_fd, VGA_BALL_WRITE_PLAYER, &player)) {
      perror("ioctl(VGA_BALL_SET_PLAYER) failed");
      return;
  }
}
void print_mouse() {
  vga_ball_mouse mouse;
  if (ioctl(vga_ball_fd, VGA_BALL_READ_MOUSE, &mouse)) {
      perror("ioctl(VGA_BALL_READ_MOUSE) failed");
      return;
  }
  mouseX = mouse.x;
  mouseY = mouse.y;
  lef = mouse.l;
  rig = mouse.r;
  mid = mouse.m;
  //printf("mouse reading %d %d %d %d %d\n",mouseX, mouseY,lef,rig,mid);
}

void set_spider(vga_ball_object *c)
{
  vga_ball_object spider;
  spider = *c;
  if (ioctl(vga_ball_fd, VGA_BALL_WRITE_SPIDER, &spider)) {
      perror("ioctl(VGA_BALL_SET_SPIDER) failed");
      return;
  }
}
void UpdateTitle(){
  int i;
  int tempH = highestScore;
  int tempS = Score;
  if(Life == 3){
    title[9] = 10;
    title[10] = 10;
    title[11] = 10;
  }
  if(Life == 2){  
    title[9] = 12;
    title[10] = 10;
    title[11] = 10;
  }  
  if(Life == 1){  
    title[9] = 12;
    title[10] = 12;
    title[11] = 10;
  }
  for(i = 6; i >= 0;i--){
    title[i]  =  tempS % 10;
    title[i +14] = tempH % 10;
    tempS /= 10;
    tempH /= 10;
  }    
}
void SetPlayer(){
    int prevX = (mouseX *47)/25;
    int prevY = (mouseY * 5)/2;
    int baseX = 0;
    int  baseY= 0;
    print_mouse(); 
    int tempX =  (mouseX * 47)/25;
    int tempY = (mouseY * 5)/2;
    if(rig == 1){
     while(isFired < 30){
       if(countBullet <32){
         countBullet++;
         break;
       }
       SetBullet();
       isFired++;
       countBullet = 0;
      }
    }
    if(isFired  >= 30){
      isFired = 0;
    }
    //printf("mouse reading %d %d\n",tempX - prevX, tempY - prevY); 
    //printf("Player reading %d %d\n",Player.x, Player.y);
    if(tempX > prevX){
      if( M[Player.x / 16 + 1][Player.y/16] == 1){
         return;
      }
      if( M[Player.x / 16 + 1][Player.y/16 + 1] == 1){
         return;
     }
     if(Player.x + tempX - prevX < 464){
	 Player.x += (tempX - prevX);
       }
    }
  
  
    
    if(tempX < prevX){
      if(M[Player.x / 16][Player.y/16] == 1){
        return;
      }
      if(M[Player.x / 16][Player.y/16+1] == 1){
       return;
      }
      if(Player.x - prevX + tempX > 0){
	Player.x -= (prevX - tempX);
      }
    }
    if(tempY < prevY){
     if(M[Player.x / 16][Player.y/16] == 1){
        return;
     }
     if(M[Player.x / 16+1][Player.y/16] == 1){
        return;
     }
     if(Player.y - (prevY - tempY) > 0){
        Player.y-= (prevY - tempY);
     }
    }
    if(tempY > prevY){
     if( M[Player.x / 16][Player.y/16 +1] == 1){
        return;
     }
     if( M[Player.x / 16+1][Player.y/16 +1] == 1){
        return;
     }
     if(Player.y + (tempY - prevY) < 624){
      Player.y+=(tempY - prevY);
     }
    }
    if(Player.x < Spider.x + 16 && Player.x > Spider.x-16 && Player.y > Spider.y - 16 && Player.y < Spider.y+16){
      Life--;
      Player.x = 450;
      Player.y = 350;
    }
    int z; 
    for(z = 0; z < 10;z++){
      if(Player.x < c[z].x+16 && Player.x > c[z].x-16 && Player.y > c[z].y-16 && Player.y < c[z].y+16){
       Life--;
      Player.x = 450;
      Player.y = 350;
      } 
    }
    
}
void UpdateBullet(){
 int i;
 int j;
 for(i = 0; i < 30; i++){
   if(b[i].dead==0){    
     if(M[b[i].x/16][b[i].y/16] == 1){
        M[b[i].x/16][b[i].y/16] = 0;
        b[i].dead = 1;
        Score+=10;
     }
     if(M[b[i].x/16][b[i].y/16 + 1] == 1){
        M[b[i].x/16][b[i].y/16 + 1] = 0; 
        b[i].dead = 1;
        Score+= 10;
     }
     if(Spider.x +16 > b[i].x && b[i].x > Spider.x-16  && Spider.y -16 < b[i].y && b[i].y < Spider.y + 16 && b[i].dead == 0){
        Spider.dead = 1;
        b[i].dead = 1;
        Score+=600;
	//printf("dead\n");
     }
     //if(Spider.x -16 <= b[i].x && b[i].x <= Spider.x  && Spider.y -16 <= b[i].y && b[i].y <= Spider.y && b[i].dead == 0){
     //   Spider.dead = 1;
     //   b[i].dead = 1;
     //}
     for(j = 0; j < 10;j++){
       if(c[j].x +16 > b[i].x && b[i].x > c[j].x-16  && c[j].y -16 < b[i].y && b[i].y <= c[j].y && c[j].dead == 0){
	  c[j].dead = 1;
          b[i].dead = 1;
          M[c[j].x / 16][c[j].y / 16] = 1;
          DieCentipede ++;
          if(c[j].head == 1){
            Score += 200;
          }else{
            Score+=100;
          }   
       }
       if(j > 0){
         if(c[j-1].dead == 1){
           c[j].head = 1;
         }
       }
     }
     if(b[i].x < 0){
        b[i].dead = 1;
     }else{
        b[i].x-=2;
     }
    
   }
 }
}
void SetBullet(){
  b[isFired].x = Player.x;
  b[isFired].y = Player.y;
  b[isFired].dead = 0;
} 
void UpdateSpider(){
   if(Spider.dead == 1){
      if(rand() % 100 < 3){
        Spider.dead = 0;
	Spider.x = (rand()%30) * 16;
        Spider.y = (rand()%40) * 16;
      }
       //Spider.x = 224;
       //Spider.y = 0;
   }
    if(Spider.x >= 464){
     Spider.x_direction = -1;
    }
    if(Spider.x <= 224){   
     Spider.x_direction = 1;
    }
    if(Spider.y >= 626){
     Spider.y_direction = -1;
    }
    if(Spider.y <=  0x00){
     Spider.y_direction = 1;
    }
    if(M[Spider.x / 16][Spider.y/16 +1]==1 && Spider.y_direction == 1){
       M[Spider.x / 16][Spider.y /16+1] = 0;
    }else  if(M[Spider.x / 16][Spider.y /16] == 1){
      M[Spider.x / 16][Spider.y /16] = 0;
    }
    Spider.x+=Spider.x_direction;
    Spider.y+=Spider.y_direction;
    if(Spider.dead == 0){
     spider.x = Spider.y;
     spider.y = Spider.x;
    }else{
     spider.x = 700;
     spider.y = 700;
    }
}
void PutMushroom(){
  int i;
  int j;
  int k;
  for(i = 0; i < 30;i++){
    for(j = 0; j < 3;j++){
      short temp = 0;
      for(k=0; k < 16;k++){
       temp |= M[i][j * 16 + k] << k;
      }
     mushroom.mushroom[i * 3 + j] = temp;
   }
 }
}
void MoveCentipede(){
  int i;
  //printf("%d %d\n",c[0].x, c[0].y);
  for(i = 0; i < 10;i++){
    if(c[i].dead == 0){
    c[i].pre_x = c[i].x;
    c[i].pre_y = c[i].y;
    if(c[i].y >= 624 || c[i].y <= 0){
      if(c[i].downcount < 16){
        c[i].x++;
        c[i].downcount++;
        if(c[i].head == 1){
          c[i].state = 5;
        }else{
          c[i].state = 4;
        }
    }
    }
     if(M[(c[i].x) / 16][(c[i].y + 16) / 16] == 1 && c[i].moveSide == 1 ){
 	if(c[i].y % 16 == 0){      
	  c[i].x++;
          c[i].downcount++;
          if(c[i].head == 1){
           c[i].state = 5;
          }else{
           c[i].state = 4;
          }
	}else{
 	   if(i < 9){
  		c[i + 1].head = 1;
	   }
        }
    }
    if(M[c[i].x / 16][c[i].y / 16] == 1 && c[i].moveSide == -1){
        c[i].x++;
        c[i].downcount++;
        if(c[i].head == 1){
          c[i].state = 5;
        }else{
          c[i].state = 4;
        }
    }
    if(c[i].downcount >0 && c[i].downcount < 16){
	c[i].x++;
        c[i].downcount++;
        if(c[i].head == 1){
          c[i].state = 5;
        }else{
          c[i].state = 4;
        }
    }
    if(c[i].downcount >= 16){
        c[i].pre_x = c[i].x;
        c[i].pre_y = c[i].y;
        c[i].moveSide *= -1;
        c[i].downcount = 0;
    }
    if(c[i].downcount == 0){
       if(c[i].head == 1){
        if(c[i].moveSide == 1){
         c[i].state = 3;
        }else{
         c[i].state = 1;
        }
       }else{
        if(c[i].moveSide == 1){
         c[i].state = 2;
        }else{
         c[i].state = 0;
        }
       }
       c[i].y += c[i].moveSide;
    } 
    if(c[i].x > 480){
      Initialization();
      Life--;
    }
    
 }
}
}

int main()
{
  printf("Game Start ");
  static const char filename[] = "/dev/vga_ball";
  vga_ball_start start;
  start.x = 0;
  set_start(&start);
  
  if ( (vga_ball_fd = open(filename, O_RDWR)) == -1) {
    fprintf(stderr, "could not open %s\n", filename);
    return -1;
  }
  srand(time(0));
  print_mouse();
  Initialization();
  int i;
  FILE *fptr;
  if((fptr = fopen("highest.txt","r")) == NULL){
    printf("ERROR! opening file");
  }
  fscanf(fptr, "%d",&highestScore);
  fclose(fptr);
  while(1) {
    printf("Value of Highest=%d\n",highestScore);
    if(DieCentipede == 10){
      Initialization();
    }
    start.x = 1; 
    set_start(&start); 
    MoveCentipede();
    UpdateSpider();
    PutMushroom();
    SetPlayer();
    UpdateBullet();
    UpdateTitle();
    for(i = 0; i < 10;i++){
     if(c[i].dead == 0){
      centipede.centipede[i*2] =c[i].y;
      centipede.centipede[i*2+1] =c[i].x;
      State.state[i] = c[i].state;
     }else{
       centipede.centipede[i*2] = 1000;
       centipede.centipede[i*2+1] =1000;
     } 
    }
    for(i = 0; i < 30;i++){
      if(b[i].dead == 0){
       bullet.bullet[i*2] = b[i].y;
       bullet.bullet[i*2+1] = b[i].x;
      }else{
       bullet.bullet[i*2] = 700+i;
       bullet.bullet[i*2+1] = 530+i;
      }
    }
    player.x = Player.y;
    player.y = Player.x;
    set_player(&player);
    set_background(&mushroom);
    set_centipede(&centipede);
    set_spider(&spider);
    set_bullet(&bullet);
    for(i = 0; i < 40;i++){
      Title.title[i] = title[i];    
    }
    set_title(&Title);
    set_state(&State);
    if(Life == 0){
      if(Score > highestScore){
       fptr = fopen("highest.txt","w");
       if(fptr==NULL){
         printf("Error");
       }
       fprintf(fptr,"%d",Score);
       fclose(fptr);
      }
      break;
    }
    usleep(5000);
  }
  return 0;
}
