#ifndef _VGA_BALL_H
#define _VGA_BALL_H

#include <linux/ioctl.h>

//type for centipede
typedef struct {
  	unsigned short centipede[20];
} vga_ball_centipede;  

//type for bullet
typedef struct {
  	unsigned short bullet[60];
} vga_ball_bullet;

//type for independent object
typedef struct {
	unsigned short x , y;
} vga_ball_object;

typedef struct{
	unsigned short mushroom[90];
}vga_ball_background;

typedef struct{
	unsigned short title[40];
}vga_ball_title;

typedef struct{
	unsigned short state[10];
}vga_ball_state;

typedef struct{
   unsigned short x,y,l,r,m;
}vga_ball_mouse;

typedef struct {
        unsigned short x;
} vga_ball_start;
#define VGA_BALL_MAGIC 'q'

/* ioctls and their arguments */
#define VGA_BALL_WRITE_BACKGROUND _IOW(VGA_BALL_MAGIC, 1, vga_ball_background *)
#define VGA_BALL_READ_BACKGROUND  _IOR(VGA_BALL_MAGIC, 2, vga_ball_background *)
#define VGA_BALL_WRITE_TITLE      _IOW(VGA_BALL_MAGIC, 9, vga_ball_title *)

//define VGA_BALL_COORDINATE
#define VGA_BALL_WRITE_CENTIPEDE _IOW(VGA_BALL_MAGIC, 3, vga_ball_centipede *)
#define VGA_BALL_WRITE_BULLET	_IOW(VGA_BALL_MAGIC, 4, vga_ball_bullet *)
#define VGA_BALL_WRITE_PLAYER	_IOW(VGA_BALL_MAGIC, 5, vga_ball_object *)
#define VGA_BALL_WRITE_SPIDER	_IOW(VGA_BALL_MAGIC, 6, vga_ball_object *)
#define VGA_BALL_WRITE_START   _IOW(VGA_BALL_MAGIC, 8, vga_ball_start *)
#define VGA_BALL_READ_MOUSE    _IOR(VGA_BALL_MAGIC, 7, vga_ball_mouse *)
#define VGA_BALL_WRITE_STATE   _IOW(VGA_BALL_MAGIC, 10, vga_ball_state *)

#endif
